<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.ds-sequence.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'ds-sequence.reduce.php',
    1 => 'Ds\\Sequence::reduce',
  ),
  'up' => 
  array (
    0 => 'class.ds-sequence.php',
    1 => 'Ds\\Sequence',
  ),
  'prev' => 
  array (
    0 => 'ds-sequence.push.php',
    1 => 'Ds\\Sequence::push',
  ),
  'next' => 
  array (
    0 => 'ds-sequence.remove.php',
    1 => 'Ds\\Sequence::remove',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'reference/ds/ds/sequence/reduce.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="ds-sequence.reduce" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">Ds\Sequence::reduce</h1>
  <p class="verinfo">(PECL ds &gt;= 1.0.0)</p><p class="refpurpose"><span class="refname">Ds\Sequence::reduce</span> &mdash; <span class="dc-title">Схлопывает коллекцию до одного значения используя callback-функцию</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-ds-sequence.reduce-description">
  <h3 class="title">Описание</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">abstract</span> <span class="modifier">public</span> <span class="methodname"><strong>Ds\Sequence::reduce</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$callback</code></span>, <span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$initial</code><span class="initializer"> = ?</span></span>): <span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span></div>

  <p class="para rdfs-comment">
   Схлопывает коллекцию до одного значения используя callback-функцию.
  </p>

 </div>


 <div class="refsect1 parameters" id="refsect1-ds-sequence.reduce-parameters">
  <h3 class="title">Список параметров</h3>
  <dl>
   
    <dt><code class="parameter">callback</code></dt>

    <dd>
     <div class="methodsynopsis dc-description"><span class="methodname"><span class="replaceable">callback</span></span>(<span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$carry</code></span>, <span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$value</code></span>): <span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span></div>

     <dl>
      
       <dt><code class="parameter">carry</code></dt>
       <dd>
        <p class="para">
         Значение, возвращённое предыдущим запуском функции или
         <code class="parameter">initial</code>, если функция запущена первый раз.
        </p>
       </dd>
      
      
       <dt><code class="parameter">value</code></dt>
       <dd>
        <p class="para">
         Значение текущей итерации.
        </p>
       </dd>
      
     </dl>
    </dd>

   
   
    <dt><code class="parameter">initial</code></dt>
    <dd>
     <p class="para">
      Начальное значение параметра carry. Можно указать <strong><code><a href="reserved.constants.php#constant.null">null</a></code></strong>.
     </p>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-ds-sequence.reduce-returnvalues">
  <h3 class="title">Возвращаемые значения</h3>
  <p class="para">
   Значение, возвращённое финальным запуском callback-функции.
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-ds-sequence.reduce-examples">
  <h3 class="title">Примеры</h3>
  <div class="example" id="example-4179">
   <p><strong>Пример #1 Пример использования <span class="function"><strong>Ds\Sequence::reduce()</strong></span> с начальным значением</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$sequence </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #0000BB">2</span><span style="color: #007700">, </span><span style="color: #0000BB">3</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">$callback </span><span style="color: #007700">= function(</span><span style="color: #0000BB">$carry</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">) {<br />    return </span><span style="color: #0000BB">$carry </span><span style="color: #007700">* </span><span style="color: #0000BB">$value</span><span style="color: #007700">;<br />};<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$sequence</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">reduce</span><span style="color: #007700">(</span><span style="color: #0000BB">$callback</span><span style="color: #007700">, </span><span style="color: #0000BB">5</span><span style="color: #007700">));<br /><br /></span><span style="color: #FF8000">// Итерации:<br />//<br />// $carry = $initial = 5<br />//<br />// $carry = $carry * 1 =  5<br />// $carry = $carry * 2 = 10<br />// $carry = $carry * 3 = 30<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">int(30)</pre>
</div>
   </div>
  </div>
  <div class="example" id="example-4180">
   <p><strong>Пример #2 Пример использования <span class="function"><strong>Ds\Sequence::reduce()</strong></span> без начального значения</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$sequence </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #0000BB">2</span><span style="color: #007700">, </span><span style="color: #0000BB">3</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$sequence</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">reduce</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$carry</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">) {<br />    return </span><span style="color: #0000BB">$carry </span><span style="color: #007700">+ </span><span style="color: #0000BB">$value </span><span style="color: #007700">+ </span><span style="color: #0000BB">5</span><span style="color: #007700">;<br />}));<br /><br /></span><span style="color: #FF8000">// Итерации:<br />//<br />// $carry = $initial = null<br />//<br />// $carry = $carry + 1 + 5 =  6<br />// $carry = $carry + 2 + 5 = 13<br />// $carry = $carry + 3 + 5 = 21<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">int(21)</pre>
</div>
   </div>
  </div>
 </div>



</div><?php manual_footer($setup); ?>